using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using MyCompany.Data;

namespace MyCompany.Rules
{
	public partial class OrdersBusinessRules : MyCompany.Data.BusinessRules
    {
        
        [ControllerAction("Orders", "Calculate", "Freight")]
        [ControllerAction("Orders", "Calculate", "Subtotal")]
        [ControllerAction("Orders", "Calculate", "Total")]
        public void CalculateOrders(
                    Nullable<int> orderID, 
                    string customerID, 
                    string customerCompanyName, 
                    Nullable<int> employeeID, 
                    string employeeLastName, 
                    Nullable<DateTime> orderDate, 
                    Nullable<DateTime> requiredDate, 
                    Nullable<DateTime> shippedDate, 
                    Nullable<int> shipVia, 
                    string shipViaCompanyName, 
                    Nullable<decimal> freight, 
                    string shipName, 
                    string shipAddress, 
                    string shipCity, 
                    string shipRegion, 
                    string shipPostalCode, 
                    string shipCountry)
        {
            UpdateFieldValue("Freight", CalculateFreight(orderID, freight));
            UpdateFieldValue("Subtotal", CalculateOrderDetailsTotal(orderID));
            UpdateFieldValue("Total", CalculateOrderDetailsTotal(orderID) + freight);
        }
        
        [RowBuilder("Orders", RowKind.New)]
        public void BuildNewOrders()
        {
            UpdateFieldValue("OrderDate", DateTime.Now);
        }
    }
}
