﻿using MyCompany.Data;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;

namespace MyCompany.Rules
{
    public partial class OrdersBusinessRules : MyCompany.Data.BusinessRules
    {
        public decimal CalculateOrderDetailsTotal(int? orderID)
        {
            using (SqlText calc = new SqlText(@"select sum(unitprice * quantity * (1 - discount)) from [Order Details] where OrderID= @OrderID"))
            {
                calc.AddParameter("@OrderID", orderID);
                object total = calc.ExecuteScalar();
                if (DBNull.Value.Equals(total))
                    return 0;
                else
                    return Convert.ToDecimal(total);

            }
        }

        public decimal CalculateFreight(int? orderID, decimal? freight)
        {
            decimal total = CalculateOrderDetailsTotal(orderID);
            if (!freight.HasValue || freight.Value == 0 || freight.Value == 3.95m || freight.Value == 19.95m)
                if (total > 100)
                    return 19.95m;
                else
                    return 3.95m;
            else
                return freight.Value;
        }
    }
}