Imports MyCompany.Data
Imports System
Imports System.Collections.Generic
Imports System.Data
Imports System.Linq
Imports System.Text.RegularExpressions
Imports System.Web

Namespace MyCompany.Rules
    
    Partial Public Class OrderDetailsBusinessRules
        Inherits MyCompany.Data.BusinessRules
        
        <ControllerAction("OrderDetails", "Calculate", "ExtendedPrice")>  _
        Public Sub CalculateOrderDetails(ByVal orderID As Nullable(Of Integer), ByVal orderCustomerID As String, ByVal orderCustomerCompanyName As String, ByVal orderEmployeeLastName As String, ByVal orderShipViaCompanyName As String, ByVal productID As Nullable(Of Integer), ByVal productProductName As String, ByVal productCategoryCategoryName As String, ByVal productSupplierCompanyName As String, ByVal unitPrice As Nullable(Of Decimal), ByVal quantity As Nullable(Of Short), ByVal discount As Nullable(Of Single))
            UpdateFieldValue("ExtendedPrice", Convert.ToDecimal(unitPrice) * Convert.ToDecimal(quantity) * (1 - Convert.ToDecimal(discount)))
        End Sub
        
        <RowBuilder("OrderDetails", RowKind.New)>  _
        Public Sub BuildNewOrderDetails()
            UpdateFieldValue("Quantity", 1)
            UpdateFieldValue("Discount", 0)
        End Sub
    End Class
End Namespace
