Imports MyCompany.Data
Imports System
Imports System.Collections.Generic
Imports System.Data
Imports System.Linq
Imports System.Text.RegularExpressions
Imports System.Web

Namespace MyCompany.Rules
    
    Partial Public Class OrdersBusinessRules
        Inherits MyCompany.Data.BusinessRules
        
        <ControllerAction("Orders", "Calculate", "Freight"),  _
         ControllerAction("Orders", "Calculate", "Subtotal"),  _
         ControllerAction("Orders", "Calculate", "Total")>  _
        Public Sub CalculateOrders( _
                    ByVal orderID As Nullable(Of Integer),  _
                    ByVal customerID As String,  _
                    ByVal customerCompanyName As String,  _
                    ByVal employeeID As Nullable(Of Integer),  _
                    ByVal employeeLastName As String,  _
                    ByVal orderDate As Nullable(Of DateTime),  _
                    ByVal requiredDate As Nullable(Of DateTime),  _
                    ByVal shippedDate As Nullable(Of DateTime),  _
                    ByVal shipVia As Nullable(Of Integer),  _
                    ByVal shipViaCompanyName As String,  _
                    ByVal freight As Nullable(Of Decimal),  _
                    ByVal shipName As String,  _
                    ByVal shipAddress As String,  _
                    ByVal shipCity As String,  _
                    ByVal shipRegion As String,  _
                    ByVal shipPostalCode As String,  _
                    ByVal shipCountry As String,  _
                    ByVal subtotal As Nullable(Of Decimal),  _
                    ByVal total As Nullable(Of Decimal))
            UpdateFieldValue("Freight", CalculateFreight(orderID, freight))
            UpdateFieldValue("Subtotal", CalculateOrderDetailsTotal(orderID))
            UpdateFieldValue("Total", CalculateOrderDetailsTotal(orderID) + freight)
        End Sub
        
        <RowBuilder("Orders", RowKind.New)>  _
        Public Sub BuildNewOrders()
            UpdateFieldValue("OrderDate", DateTime.Now)
        End Sub
    End Class
End Namespace
