Imports MyCompany.Data
Imports System
Imports System.Collections.Generic
Imports System.Data
Imports System.Linq

Namespace MyCompany.Rules
    
    Partial Public Class OrdersBusinessRules
        Inherits MyCompany.Data.BusinessRules

        Public Function CalculateOrderDetailsTotal(ByRef orderID As Nullable(Of Integer)) As Decimal
            Using calc As SqlText = New SqlText( _
                "select sum(unitprice * quantity * (1 - discount)) from [Order Details] where OrderID= @OrderID")
                calc.AddParameter("@OrderID", orderID)
                Dim total As Object = calc.ExecuteScalar()
                If DBNull.Value.Equals(total) Then
                    Return 0
                Else
                    Return Convert.ToDecimal(total)
                End If
            End Using
        End Function

        Public Function CalculateFreight(ByRef orderID As Nullable(Of Integer), _
                                 ByRef freight As Nullable(Of Decimal)) As Decimal
            Dim total As Decimal = CalculateOrderDetailsTotal(orderID)
            If Not freight.HasValue Or freight.Value = 0 Or freight.Value = 3.95 Or freight.Value = 19.95 Then
                If total >= 100 Then
                    Return 19.95
                Else
                    Return 3.95
                End If
            Else
                Return freight.Value
            End If
        End Function

    End Class
End Namespace
